package adshttp

import (
	"fmt"
	authmiddleware "legalgo-BE-go/internal/api/http/middleware/auth"
	adsdomain "legalgo-BE-go/internal/domain/ads"
	adssvc "legalgo-BE-go/internal/services/ads"
	"legalgo-BE-go/internal/utilities/response"
	"legalgo-BE-go/internal/utilities/utils"
	"net/http"

	"github.com/go-chi/chi/v5"
	"github.com/go-playground/validator/v10"
)

func Update(
	router chi.Router,
	validate *validator.Validate,
	adsSvc adssvc.Ads,
) {
	router.
		With(authmiddleware.Authorize()).
		Put("/ads/{ads_id}/update", func(w http.ResponseWriter, r *http.Request) {
			ctx := r.Context()
			adsID := chi.URLParam(r, "ads_id")

			if adsID == "" {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					fmt.Errorf("ads id is not provided"),
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"ads id is not provided",
				)
				return
			}

			var spec adsdomain.AdsReq
			if err := utils.UnmarshalBody(r, &spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					"failed to unmarshal body",
				)
				return
			}

			if err := validate.Struct(spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.(validator.ValidationErrors).Error(),
				)
				return
			}

			if err := adsSvc.Update(adsID, spec); err != nil {
				response.RespondJsonErrorWithCode(
					ctx,
					w,
					err,
					response.ErrBadRequest.Code,
					response.ErrBadRequest.HttpCode,
					err.Error(),
				)
				return
			}

			response.RespondJsonSuccess(ctx, w, struct {
				Message string
			}{
				Message: "update ads success",
			})
		})
}
